<?xml version='1.1' encoding='UTF-8'?>
<flow-build plugin="workflow-job@1400.v7fd111b_ec82f">
  <actions>
    <hudson.model.ParametersAction>
      <safeParameters class="sorted-set"/>
      <parameters>
        <hudson.model.StringParameterValue>
          <name>DOMAIN</name>
          <description>domain name</description>
          <value>idubi</value>
        </hudson.model.StringParameterValue>
        <hudson.model.StringParameterValue>
          <name>REPONAME</name>
          <description>repository name</description>
          <value>curl</value>
        </hudson.model.StringParameterValue>
      </parameters>
      <parameterDefinitionNames>
        <string>DOMAIN</string>
        <string>REPONAME</string>
      </parameterDefinitionNames>
    </hudson.model.ParametersAction>
    <hudson.model.CauseAction>
      <causeBag class="linked-hash-map">
        <entry>
          <hudson.model.Cause_-UserIdCause>
            <userId>admin</userId>
          </hudson.model.Cause_-UserIdCause>
          <int>1</int>
        </entry>
      </causeBag>
    </hudson.model.CauseAction>
    <jenkins.metrics.impl.TimeInQueueAction plugin="metrics@4.2.21-449.v6960d7c54c69">
      <queuingDurationMillis>2</queuingDurationMillis>
      <blockedDurationMillis>0</blockedDurationMillis>
      <buildableDurationMillis>0</buildableDurationMillis>
      <waitingDurationMillis>0</waitingDurationMillis>
    </jenkins.metrics.impl.TimeInQueueAction>
    <org.jenkinsci.plugins.workflow.libs.LibrariesAction plugin="pipeline-groovy-lib@704.vc58b_8890a_384">
      <libraries/>
    </org.jenkinsci.plugins.workflow.libs.LibrariesAction>
    <org.jenkinsci.plugins.pipeline.modeldefinition.actions.ExecutionModelAction plugin="pipeline-model-definition@2.2198.v41dd8ef6dd56">
      <stagesUUID>b04d6942-f7b2-4758-b012-754d5ef7a546</stagesUUID>
      <pipelineDefs>
        <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTPipelineDef plugin="pipeline-model-api@2.2198.v41dd8ef6dd56">
          <stages>
            <stages>
              <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTStage>
                <name>Setup Python Environment</name>
                <branches>
                  <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTBranch>
                    <name>default</name>
                    <steps>
                      <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTScriptBlock>
                        <name>script</name>
                        <args class="org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTNamedArgumentList">
                          <arguments class="linked-hash-map">
                            <entry>
                              <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTKey>
                                <key>scriptBlock</key>
                              </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTKey>
                              <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTValue_-ConstantValue>
                                <value class="string">if (!fileExists(&quot;venv&quot;)) {
                        sh &apos;python -m venv venv&apos;
                        sh &apos;source ./venv/bin/activate&apos;
                    }</value>
                              </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTValue_-ConstantValue>
                            </entry>
                          </arguments>
                        </args>
                      </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTScriptBlock>
                    </steps>
                  </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTBranch>
                </branches>
              </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTStage>
              <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTStage>
                <name>get curl docker builder</name>
                <branches>
                  <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTBranch>
                    <name>default</name>
                    <steps>
                      <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTScriptBlock>
                        <name>script</name>
                        <args class="org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTNamedArgumentList">
                          <arguments class="linked-hash-map">
                            <entry>
                              <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTKey>
                                <key>scriptBlock</key>
                              </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTKey>
                              <org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTValue_-ConstantValue>
                                <value class="string">sh  &apos;docker run -d --name curl-execution --privileged -v /var/jenkins-agent/workspace/curl-clone:/app  -v /logs:/logs -v /artifacts:/artifacts idubi/curl-ubuntu-operator:latest&apos;</value>
                              </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTValue_-ConstantValue>
                            </entry>
                          </arguments>
                        </args>
                      </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTScriptBlock>
                    </steps>
                  </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTBranch>
                </branches>
              </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTStage>
            </stages>
            <uuid>b04d6942-f7b2-4758-b012-754d5ef7a546</uuid>
          </stages>
          <agent>
            <variables class="org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTValue$ConstantValue">
              <value class="string">jenkins-agent</value>
            </variables>
            <agentType>
              <key>label</key>
            </agentType>
          </agent>
        </org.jenkinsci.plugins.pipeline.modeldefinition.ast.ModelASTPipelineDef>
      </pipelineDefs>
    </org.jenkinsci.plugins.pipeline.modeldefinition.actions.ExecutionModelAction>
    <com.cloudbees.plugins.credentials.builds.CredentialsParameterBinder plugin="credentials@1337.v60b_d7b_c7b_c9f">
      <boundCredentials class="concurrent-hash-map"/>
    </com.cloudbees.plugins.credentials.builds.CredentialsParameterBinder>
    <hudson.plugins.git.util.BuildData plugin="git@5.2.2">
      <buildsByBranchName>
        <entry>
          <string>origin/main</string>
          <hudson.plugins.git.util.Build>
            <marked plugin="git-client@4.7.0">
              <sha1>f3c085c6cdbc3073f3c2dced0d17713ccbaaa393</sha1>
              <branches class="list">
                <hudson.plugins.git.Branch>
                  <sha1 reference="../../../sha1"/>
                  <name>origin/main</name>
                </hudson.plugins.git.Branch>
              </branches>
            </marked>
            <revision reference="../marked"/>
            <hudsonBuildNumber>18</hudsonBuildNumber>
          </hudson.plugins.git.util.Build>
        </entry>
      </buildsByBranchName>
      <lastBuild reference="../buildsByBranchName/entry/hudson.plugins.git.util.Build"/>
      <remoteUrls>
        <string>https://github.com/idubi/curl</string>
      </remoteUrls>
    </hudson.plugins.git.util.BuildData>
    <org.jenkinsci.plugins.workflow.steps.scm.MultiSCMRevisionState plugin="workflow-scm-step@427.v4ca_6512e7df1">
      <revisionStates>
        <entry>
          <string>git https://github.com/idubi/curl</string>
          <hudson.scm.SCMRevisionState_-None/>
        </entry>
      </revisionStates>
    </org.jenkinsci.plugins.workflow.steps.scm.MultiSCMRevisionState>
    <jenkins.metrics.impl.SubTaskTimeInQueueAction plugin="metrics@4.2.21-449.v6960d7c54c69">
      <queuingDurationMillis>4</queuingDurationMillis>
      <blockedDurationMillis>0</blockedDurationMillis>
      <buildableDurationMillis>3</buildableDurationMillis>
      <waitingDurationMillis>0</waitingDurationMillis>
      <executingDurationMillis>1936</executingDurationMillis>
      <workUnitCount>1</workUnitCount>
    </jenkins.metrics.impl.SubTaskTimeInQueueAction>
  </actions>
  <queueId>34</queueId>
  <timestamp>1715276046014</timestamp>
  <startTime>1715276046019</startTime>
  <result>SUCCESS</result>
  <duration>3452</duration>
  <charset>UTF-8</charset>
  <keepLog>false</keepLog>
  <execution class="org.jenkinsci.plugins.workflow.cps.CpsFlowExecution">
    <result>SUCCESS</result>
    <script>// // properties([  parameters([ string(defaultValue: &apos;idubi&apos;, description: &apos;domain name&apos;, name: &apos;DOMAIN&apos;, trim: true),
// //                           string(defaultValue: &apos;curl&apos;, description: &apos;repository name&apos;, name: &apos;REPONAME&apos;, trim: true)
// //                         ])
// ])
pipeline {
    agent {
        label &apos;jenkins-agent&apos;
    }
    stages {
        stage(&apos;Setup Python Environment&apos;) {
            steps {
                script {
                    // Check if the virtual environment exists, if not create it
                    if (!fileExists(&quot;venv&quot;)) {
                        sh &apos;python -m venv venv&apos;
                        sh &apos;source ./venv/bin/activate&apos;
                    }
                }
            } 
        }
        stage(&apos;get curl docker builder&apos;) {
            steps {
                script {
                   sh  &apos;docker run -d --name curl-execution --privileged -v /var/jenkins-agent/workspace/curl-clone:/app  -v /logs:/logs -v /artifacts:/artifacts idubi/curl-ubuntu-operator:latest&apos;
                }
            } 
        }

        // stage(&apos;wait untll build ends&apos;) {
        //     steps {
        //         // script {
        //         //    while container_is_up(&apos;curl-execution&apos;) {
        //         //         sleep(10)
        //         //     }
        //         // }
        //     } 
        // }
        // stage(&apos;stop curl container and delete it&apos;) {
        //     steps {
        //         script {
        //            sh  &apos;docker stop curl-execution&apos;
        //            sh  &apos;docker rm curl-execution&apos;
        //         }
        //     } 
        // }

        // stage(&apos;Manage Docker Container - prior condition posgres db need to be up&apos;) {
        //     steps {
        //         script {
        //                 withCredentials([usernamePassword(credentialsId: &apos;docker-idubi&apos; , usernameVariable: &apos;DOCKER_USERNAME&apos;, passwordVariable: &apos;DOCKER_PASSWORD&apos;)]) {
        //                             sh &apos;&apos;&apos;#!/bin/bash
        //                                   chmod -R +x ./jenkins-flow-scripts/bash
        //                                   source jenkins-flow-scripts/bash/docker-utils.sh 
        //                                   # [1. container name]  [2. image name]  [3. docker run command if no container] [4,5 - docker credentials]
        //                                   prepare_docker_container &quot;postgres-idubi&quot; \
        //                                           &quot;postgres&quot;  \
        //                                           &quot;docker run --name postgres-idubi -e POSTGRES_USER=idubi -e POSTGRES_PASSWORD=idubi -d -p 5432:5432 postgres&quot; \
        //                                           $DOCKER_USERNAME \
        //                                           $DOCKER_PASSWORD 
        //                                &apos;&apos;&apos;                                    
        //                         }
        //         }
        //     }
        // }
        // stage(&apos;build curl Application&apos;) 
        // {
        //     steps {
        //         script {
        //                 // Run the Flask application in no hup so it will not ber stuck
        //                 // sh &apos;nohup python src/app.py&gt;app_1.log&amp;&apos;
        //                 sh &apos;nohup python src/app.py&gt;app_1.log&amp;&apos;
        //         }
        //     }
        // }
        // stage(&apos;test sanity for application&apos;) 
        // {
        //     steps {
        //         script {
        //                 sh &apos;&apos;&apos;#!/bin/bash
        //                     source jenkins-flow-scripts/bash/test-flask-app.sh
        //                                             [1.flask app endpoint]   [2.#retries]  [3.interval secconds]
        //                     validate_flask_in_loop &quot;http://127.0.0.1:5000&quot;     10              3  
        //                     # kill the application after test completed
        //                     pkill -f &quot;python.*src/app.py&quot;                     
        //                 &apos;&apos;&apos;
        //         }
        //     }
        // }
        // stage(&apos;build docker image &apos;) 
        // {
        //     steps {
        //         script {
        //             withCredentials([usernamePassword(credentialsId: &apos;docker-idubi&apos; , usernameVariable: &apos;DOCKER_USERNAME&apos;, passwordVariable: &apos;DOCKER_PASSWORD&apos;)]) 
        //             {
        //             sh &apos;&apos;&apos;#!/bin/bash
        //                 source jenkins-flow-scripts/bash/docker-utils.sh 
        //                 # since we are connecting to the db in docker compose with same port as the db , 
        //                 # and we open it for tests in host - we need to stop db (port is already allocated error)
        //                 #               [1.  container name ]
        //                 stop_container &apos;postgres-idubi&apos;
        //                 # echo &quot; domain ---&gt; $DOMAIN&quot;
        //                 # echo &quot; DOCKER_USERNAME ---&gt; $DOCKER_USERNAME&quot;

        //                 #    [1. domain]   [2. app name]     [3.dockerfile path]  &apos;TAG VERSION&apos; --&gt; 0.0.0 from build , later on version will be handles
        //                 build_docker_image  $DOCKER_USERNAME $DOCKER_PASSWORD  $DOMAIN   $REPONAME  &apos;./src/&apos; &apos;0.0.0&apos;
                        
        //             &apos;&apos;&apos;
        //             }
        //         }
        //     }            
        // }
        // stage(&apos;load docker image in docker compose - for testing inside container&apos;)       
        // {
        //     steps {
        //         script{
        //                 //  we allready arive here after logged into docker so no need to 
        //                 //  load docker credentials agin
        //                 sh &apos;&apos;&apos;#!/bin/bash
        //                     source jenkins-flow-scripts/bash/docker-utils.sh 
        //                     #                        [1. compose file path]         [2. docker build name]  [3. compose image prefix]
        //                     build_docker_compose  &apos;src/docker-compose-image.yml&apos;  &quot;$REPONAME:0.0.0&quot;    &quot;$REPONAME-compose&quot;
        //                 &apos;&apos;&apos;
        //         }
        //     }
        // } 
        // stage(&apos;test sanity for docker&apos;) 
        // {
        //     steps {
        //         script {
        //                 sh &apos;&apos;&apos;#!/bin/bash
        //                     source jenkins-flow-scripts/bash/test-flask-app.sh
        //                                             [1.flask app endpoint]   [2.#retries]  [3.interval secconds]
        //                     validate_flask_in_loop &quot;http://127.0.0.1:5000&quot;     10               3  
        //                     source jenkins-flow-scripts/bash/docker-utils.sh
        //                     stop_docker_compose &apos;src/docker-compose-image.yml&apos; &quot;$DOMAIN/$REPONAME:0.0.0&quot;  &apos;flask-compose&apos;
        //                 &apos;&apos;&apos;                        
        //         }
        //     }
        // }
    }
    // post  {
    //         always  {  
    //               script {    
    //                     sh &apos;&apos;&apos;#!/bin/bash
    //                         source jenkins-flow-scripts/bash/docker-utils.sh  
    //                         stop_docker_compose &apos;src/docker-compose-image.yml&apos;  &apos;idubi/flask-crud:lts&apos;    &apos;flask-compose&apos;      
    //                         stop_container &apos;postgres-idubi&apos;
    //                         stop_container &apos;flask-compose-web-app&apos;
    //                         stop_container &apos;flask-compose-postgres-db&apos;
    //                     &apos;&apos;&apos;
    //               }
    //             }
    //         }
}     

       
        // stage(&apos;execute in kubernates&apos;){
        //         steps{
        //             script{
        //                 sh &apos;kubectl apply -f ./kubernetes/&apos;   
        //                 sh &apos;minikube service web-app --namespace flaskapp-python&apos;
        //             }

        //         }
        //     }
    // }

     
</script>
    <loadedScripts class="linked-hash-map"/>
    <durabilityHint>MAX_SURVIVABILITY</durabilityHint>
    <timings class="map">
      <entry>
        <string>flowNode</string>
        <long>160689623</long>
      </entry>
      <entry>
        <string>classLoad</string>
        <long>391296487</long>
      </entry>
      <entry>
        <string>run</string>
        <long>748503208</long>
      </entry>
      <entry>
        <string>parse</string>
        <long>44711623</long>
      </entry>
      <entry>
        <string>saveProgram</string>
        <long>167978441</long>
      </entry>
    </timings>
    <internalCalls class="sorted-set">
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.SyntheticStageNames.checkout</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.Utils.createStepsBlock</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.Utils.getRestartedStage</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.Utils.updateJobProperties</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.Utils.updateRunAndJobActions</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.customWorkspace</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.getScript</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.hasScmContext</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.inStage</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.isDoCheckout</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.label</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.retries</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.reuseRootAgent</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.agent.impl.Label.subdirectory</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Agent.&lt;init&gt;</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Agent.getDeclarativeAgent</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Agent.hasAgent</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Agent.populateMap</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Agent.rawClosure</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.&lt;init&gt;</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.agent</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.astUUID</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.environment</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.getEnvVars</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.hasSatisfiedConditions</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.libraries</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.options</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.parameters</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.post</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.stages</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.tools</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Root.triggers</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.&lt;init&gt;</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.agent</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.environment</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.getEnvVars</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.getMatrixCellEnvVars</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.input</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.name</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.options</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.parallel</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.post</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.stages</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.steps</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.tools</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stage.when</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stages.&lt;init&gt;</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.Stages.stages</string>
      <string>org.jenkinsci.plugins.pipeline.modeldefinition.model.StepsBlock.closure</string>
      <string>org.jenkinsci.plugins.workflow.cps.persistence.IteratorHack$Itr.hasNext</string>
      <string>org.jenkinsci.plugins.workflow.cps.persistence.IteratorHack$Itr.next</string>
      <string>org.jenkinsci.plugins.workflow.support.steps.build.RunWrapper.result</string>
    </internalCalls>
    <sandbox>true</sandbox>
    <iota>34</iota>
    <head>1:34</head>
    <done>true</done>
    <resumeBlocked>false</resumeBlocked>
    <storageDir>workflow-completed</storageDir>
  </execution>
  <completed>true</completed>
  <checkouts class="hudson.util.PersistedList">
    <org.jenkinsci.plugins.workflow.job.WorkflowRun_-SCMCheckout>
      <scm class="hudson.plugins.git.GitSCM" plugin="git@5.2.2">
        <configVersion>2</configVersion>
        <userRemoteConfigs>
          <hudson.plugins.git.UserRemoteConfig>
            <url>https://github.com/idubi/curl</url>
            <credentialsId>github-credentials</credentialsId>
          </hudson.plugins.git.UserRemoteConfig>
        </userRemoteConfigs>
        <branches>
          <hudson.plugins.git.BranchSpec>
            <name>main</name>
          </hudson.plugins.git.BranchSpec>
        </branches>
        <doGenerateSubmoduleConfigurations>false</doGenerateSubmoduleConfigurations>
        <submoduleCfg class="empty-list"/>
        <extensions/>
      </scm>
      <node>jenkins-agent</node>
      <workspace>/var/jenkins-agent/workspace/curl-clone</workspace>
      <changelogFile>/var/jenkins_home/jobs/curl-clone/builds/18/changelog6797318348983124041.xml</changelogFile>
      <pollingBaseline class="hudson.scm.SCMRevisionState$None" reference="../../../actions/org.jenkinsci.plugins.workflow.steps.scm.MultiSCMRevisionState/revisionStates/entry/hudson.scm.SCMRevisionState_-None"/>
    </org.jenkinsci.plugins.workflow.job.WorkflowRun_-SCMCheckout>
  </checkouts>
</flow-build>